function that=lincombine(arg1,arg2,c1,c2)
% add matrix and constant
% or
% add matrices

if strcmp(class(arg1),'deflate')
    %initialize with arg1
    that=emptycopy(arg1);
    if strcmp(class(arg2),'deflate') 
        if ~isequalsize(arg1,arg2)
            %add 2 deflated matrices
            error('Adding matrices of different size not allowed');
        end
        that.data=lincombine(arg1.data,arg2.data,c1,c2);
    else
        that.data=lincombine(arg1.data,arg2(:),c1,c2)
    end
else
    %initialize with arg2
    that=emptycopy(arg2);
    that.data=lincombine(arg1(:),arg2.data,c1,c2)
end

