function attribute=get(obj,prop)
%Return property of object
property=getproperty(prop,{'size','class','segmentSize','mode','data'});

switch property
    case 'size'
        attribute=obj.size;
    case {'class','segmentSize','mode','emptyvalue'}
        attribute=get(obj.data,property);
    case 'data'
        attribute=obj.data;
    otherwise
        error('deflate object does not have property %s',property)
end